//*************************************************
// CENTRALINA PER AUTOMATIZZARE LE PERSIANE
//
// modulo: main.c
// autore: Longhi Ferdinando
// data: 08/06/2012
// descrizione: centralina per persiane a 2 ante
// picmicro: PIC16F88
// clock: 8MHz interno
// NOTE:gestione della velocit con PWM
//
// http://www.settorezero.com
//*************************************************

#define  XTAL_FREQ 8MHZ // questo  utilizzato dalle routine di ritardo contenute in Delay.C
#include <htc.h>
#include "settings.h"//qui trovo i settaggio generali
#include "delay.c" // routine per ritardi
#include "pwm.c"// rourine PWM
__CONFIG (FOSC_INTOSCIO & WDTE_OFF & PWRTE_OFF & BOREN_OFF & LVP_OFF & CPD_OFF & WRT_OFF & DEBUG_OFF & CP_OFF & CCPMX_RB3);
void main(void)
{
settings();
PWMSetup();
Out1=0;//tutti..
Out2=0;//...i motori...
Out3=0;//...sono a ...
Out4=0;//...riposo
duty=512;//metto a 1 il pin enable del L293D
PWMDuty(duty);

	while(1) // eseguo un ciclo finito
	{

//*************************************************
// inizio controllo pulsante apre/stop/chiude
//*************************************************	
		while (1)
		{
		if (Pul==0)//verifico se e' premuto il pulsante
			{
			while (!Pul)//aspetto che rilascio il pulsante
					{
					}
//*************************************************
// Apro la prima anta
//*************************************************	
					Out1=1;//Apro la prima anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per uscire dal while
					while (Brk)
					{
						if (Sec >=Time1)//verifico se e' scaduto il tempo
						{
							Brk=0;//esco dal while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=200;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}
							Out1=0;
							duty=512;//duty cycle 100%
							PWMDuty(duty);
						}
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
								{
								Out1=0;//fermo la prima anta
								Brk=0;//esco dal while
								}
						}
						else if (Pul==0)//verifico se e' premuto il pulsante
								{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								}
							Out1=0;//fermo la prima anta
							Brk=0;//esco dal while
								}//fine if
					}//fine while
			//}//fine if
		//}//fine while
		//*************************************************
		// Apro la seconda anta
		//*************************************************	
					DelayMs(250);//attendo per evitare false letture di amperostop
					Out2=1;//Apro la seconda anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per restare nel while
					while (Brk)
					{
						if (Sec >=Time2)//verifico se e' scaduto il tempo
						{
							Brk=0;//esco dall while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=200;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}//fine while
							Out2=0;
							duty=512;//duty cycle di circa 100%
							PWMDuty(duty);
						}//fine if
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
							{
								Out2=0;//fermo la seconda anta
								Brk=0;//esco dall while
							}//fine if
						}//fine if
						else if (Pul==0)//verifico se e' premuto il pulsante
						{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								}
							Out2=0;//fermo la seconda anta
							Brk=0;//esco dall while
						}
						//}//fine if
					}//fine while
					break;				
			}//fine if
		}//fine while	
//*************************************************
// inizio controllo pulsante apre/stop/chiude
//*************************************************	
		while (1)
		{
			if (Pul==0)//verifico se e' premuto il pulsante
			{
				while (!Pul)//aspetto che rilascio il pulsante
					{
					}
	//*************************************************
	// Chiudo la seconda anta
	//*************************************************	
					Out3=1;//Chiudo la seconda anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per restare nel while
					while (Brk)
					{
						if (Sec >=Time3)//verifico se e' scaduto il tempo
						{
							Brk=0;//esco dall while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=200;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}
							duty=512;//duty cycle di circa 100%
							PWMDuty(duty);
							DelayMs(250);//...per mezzo secondo...
							Out3=0;//...per accostarla bene
						}
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;//punto di partenza per in tempo del amperostop
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
								{
								Out3=0;//fermo la prima anta
								Brk=0;//esco dall while
								}
						}
						else if (Pul==0)//verifico se e' premuto il pulsante
								{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								}
								Out3=0;//fermo la prima anta
								Brk=0;//esco dall while
								}//fine if
						}//fine while
					//}
					//}
//*************************************************
// Chiudo la prima anta
//*************************************************	
					DelayMs(250);//attendo per evitare false letture di amperostop
					Out4=1;//Apro la prima anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per restare nel while
					while (Brk)
					{
						if (Sec >=Time4)//verifico se e' scaduto il tempo
						{
							//Out4=0;//Fermo la prima anta
							Brk=0;//esco dal while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=200;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}
							duty=512;//duty cycle di circa 100%
							PWMDuty(duty);
							DelayMs(250);//per mezzo secondo...
							Out4=0;//...per accostarla bene
						}
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;//punto di partenza per in tempo del amperostop
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
								{
								Out4=0;//fermo la prima anta
								Brk=0;//Fermo la prima anta
								}
						}
						else if (Pul==0)//verifico se e' premuto il pulsante
								{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								}
								Out4=0;//fermo la prima anta
								Brk=0;//Fermo la prima anta
								}//fine if
						//}//fine if
					}//fine while
					break;
				}//fine if
		}//fine while		
	}// Fine ciclo continuo
}// Fine main

void interrupt ISR (void)
 {
    if (TMR0IF) // L'interrupt  stato causato da un overflow del timer0 ?
       {
       TMR0 = 194; // Reimposto Timer0
       Time++; // Incremento il Time
       if (Time >= 1000) // Se   passato un secondo...
          {
          Sec++; // ...incremento la variabile
          Time=0; // azzero il time per un nuovo conteggio del tempo 
          }
       TMR0IF=0; // Resetto il flag interrupt su timer 0,
       } // fine che interrupt verificatosi su timer0
 } // fine interrupt 